#!/etc/opt/openit/perl -w

BEGIN {
    push @INC, "/opt/openit/contrib/lib";
}

use strict;
use OpeniT::Contrib::Config;

my $cfg = "/var/opt/openit/etc/freezemon.conf";
my $old = "/var/opt/openit/etc/freezemon.conf.old";
my $new = "/var/opt/openit/etc/freezemon.conf.new";

my @conf;

# Only root can patch
if ( $< ne 0 ) {
    die "Error: Patching must be done as 'root'!\n";
}

# Get server info from global config file

my $config = new OpeniT::Contrib::Config; 
$config->read("/etc/opt/openit/openit_contrib.cfg");
my $server = $config->{SERVER};

# Read in config
open(IN, "$cfg") || die "Error: Unable to read old cfg '$cfg'!\n";
@conf = <IN>;
close(IN);

# config already updates?
exit 0 if ( grep(/protocol/, @conf) );

# If must insert new lines

open(OUT, ">$new") || die "Error: Can't write new cfg '$new'!\n";

# Add protocol line
foreach my $line (@conf) {
    if($line =~ /^freezemonitor/) {
	print OUT "protocol()=\"\"
{
\tnetwork()=\"\"
\t{
\t\tserver-name(String)=\"$server\"{}
\t\tserver-port(NetworkPort)=\"7478\"{}
\t}
}\n";
    }
    print OUT $line;
}

close(OUT);

if( ! rename($cfg, $old)) {
    die "Error: Unable to previous config to '$old'!\n";
}

if( ! rename($new, $cfg)) {
    die "Error: Unable to rename new config to '$cfg'!\n";
}

exit 0;
